/* Optimizer, both for the bytecode compiler and the compiler to C (unused), headers.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef struct OptAssum {
  congPtr defeqs; /* definite equalities */
  congPtr poseqs; /* possible equalities */
} OptAssum;

	/* infos for definite equalities: */
typedef ExprPtr defInfoPtr;

#define N_DEFINFO 5
#define DEFINFO_COST 0
	/* cost of evaluation of the object */
#define DEFINFO_PREFERRED 1
	/* preferred expression of the color (the one with lowest cost) */
#define DEFINFO_TYPE 2
	/* type; see also POSINFO_TYPE */
#define DEFINFO_FUN_BODIES 3
	/* map from function bodies to their cost at application;
	   see Z_LAMBDA below. */
#define DEFINFO_VAR 4
	/* a variable that holds the expression (or NIL). */

	/* infos for possible equalities */
typedef ExprPtr posInfoPtr;

#define N_POSINFO 2

#define POSINFO_TYPE 0
	/* this type is always boxed for results of whole ML expressions;
	   it is unboxed only for applications of unboxing functions
	   or for arguments of boxing functions. In particular, as
	   all compiled expressions are typable, types will always agree,
	   modulo implementation-level conversions (boxing/unboxing). */

#define BOXED_VOID 0
#define BOXED_ANY 1
#define BOXED_STRING 2
#define UNBOXED_STRING 3
#define BOXED_REAL 4
#define UNBOXED_REAL 5
#define BOXED_COMPLEX 6
#define UNBOXED_COMPLEX 7
#define BOXED_NUM 8
#define UNBOXED_NUM 9
	/* num is real or complex */
#define BOXED_BOOL 10
#define UNBOXED_BOOL 11
#define BOXED_REF 12
#define BOXED_ARRAY 13
#define BOXED_NIL 14
#define BOXED_CONS 15
#define BOXED_LIST 16
	/* list is nil or cons */
#define BOXED_TUPLE_START 17
#define BOXED_TUPLE_0 BOXED_TUPLE_START+1
#define BOXED_TUPLE_1 BOXED_TUPLE_START+2
#define BOXED_TUPLE_2 BOXED_TUPLE_START+4
#define BOXED_TUPLE_GNRL BOXED_TUPLE_START+8
