(* test a few things about catch/throw *)

ok "catch" (catch (fn k => 1)=1 andalso
	     let fun f k = 1 (* same test, but cont. handler is not explicit *)
	     in
		 catch f=1
	     end andalso
	     (* now, test behavior of continuations to simulate exceptions *)
	     catch (fn k => 3+throw k 5)=5 andalso
	     let fun f k = 3+throw k 5
	     in
		 catch f=5
	     end andalso
	     (* with catch, we cannot do any time-warp as with callcc:
	      throw a continuation after getting out of its lexically defining scope
	      and check that exception Catch is raised.
	      *)
	     let val r = ref NONE
		 val n = 1+catch (fn k => (r := SOME k;
					    1))
	     in
		 if n=2
		     then case r of ref (SOME k) => throw k 3
			 handle Catch => 5
		 else n
	     end = 5);
