(* A few operation on finite sets.
   Copyright (C) 1992-1995 Jean Goubault and Bull S.A.
   All rights reserved.

   Redistribution and use in source and binary forms are permitted provided
   that: (1) source distributions retain this entire copyright notice and
   comment, and (2) distributions including binaries display the following
   acknowledgement:  ``This product includes software developed by Jean
   Goubault as a contributor of Bull S.A.'' in the
   documentation or other materials provided with the distribution and in
   all advertising materials mentioning features or use of this software.
   Neither the name of Bull S.A. or of its corporate affiliates,
   nor the names of its contributors may be used to endorse or promote
   products derived from this software without specific prior written permission.
   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*)

fun image f s = {f x | x in set s}  (* image of the set s through the function f *)
	(* image : (''a -> ''b) -> (''a -m> 'c) -> ''b set *)
fun disjoint_union(s1,s2) = {(x,false) | x in set s1} U {(x,true) | x in set s2}
	(* disjoint_union : (''a -m> 'b) * (''a -m> 'c) -> (''a * bool) set *)
fun product(s1,s2) = {(x,y) | x in set s1 and y in set s2}  (* cartesian product *)
	(* product : (''a -m> 'b) * (''c -m> 'd) -> (''a * ''c) set *)
fun P s = {x | x sub map s} (* computes set of submaps of s (the powerset of s when s is a set) *)
	(* P : (''a -m> ''b) -> (''a -m> ''b) set *)
fun total_maps {} s2 = {{}}
	|   total_maps {x => _} U rest1 s2 =
	{f ++ {x => y} | y in set s2 and f in set total_maps rest1 s2}
	(* total_maps s1 s2 is the set of total maps from s1 to s2 *)
	(* total_maps : (''a -m> 'b) -> (''c -m> 'd) -> (''a -m> ''c) set *)
