/* Definitions for shared structure allocation functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

EXTERN ExprPtr *Ktuple2Table;
EXTERN ExprPtr *KonsTable;
EXTERN ExprPtr *MapletKonsTable;
EXTERN ExprPtr *MapKonsTable;
EXTERN ExprPtr *KcomplexTable;
EXTERN ExprPtr *KtypeApplTable;
EXTERN ExprPtr *KtypeFxTable;
EXTERN ExprPtr *Krecord1Table;
EXTERN ExprPtr *DataTable;
EXTERN ExprPtr *IntTable;
EXTERN ExprPtr *RealTable;
EXTERN ExprPtr *StringTable;
EXTERN ExprPtr *VarTable;
EXTERN ExprPtr *RefTable;
EXTERN ExprPtr *ExtTable;
EXTERN ExprPtr *ArrayTable;
EXTERN CHAR *theChars;
EXTERN ExprPtr voidString;
EXTERN ExprPtr *charStrings;

EXTERN unsigned long ktuple2_hash_size,kons_hash_size,
  mapletkons_hash_size,mapkons_hash_size,kcomplex_hash_size,
  ktypeappl_hash_size,ktypefx_hash_size,krecord1_hash_size;
EXTERN unsigned long data_hash_size;
EXTERN unsigned long int_hash_size,real_hash_size;
EXTERN unsigned long string_hash_size,array_hash_size;

/*
#define pair_hashcode(car,cdr) \
	(((((unsigned long)car)+((unsigned long)cdr)))>>NLOWBITS) & (PAIR_HASH_SIZE-1)
*/
   /* works only because PAIR_HASH_SIZE is a power of 2. */

#define pair_hashcode1(car,cdr,siz) \
	((((unsigned long)car)+((unsigned long)cdr)) >> NLOWBITS) % (siz)
#define ktuple2_hashcode(car,cdr) pair_hashcode1(car,cdr,ktuple2_hash_size)
#define kons_hashcode(car,cdr) pair_hashcode1(car,cdr,kons_hash_size)
#define mapletkons_hashcode(car,cdr) pair_hashcode1(car,cdr,mapletkons_hash_size)
#define mapkons_hashcode(car,cdr) pair_hashcode1(car,cdr,mapkons_hash_size)
#define kcomplex_hashcode(car,cdr) pair_hashcode1(car,cdr,kcomplex_hash_size)
#define ktypeappl_hashcode(car,cdr) pair_hashcode1(car,cdr,ktypeappl_hash_size)
#define ktypefx_hashcode(car,cdr) pair_hashcode1(car,cdr,ktypefx_hash_size)
#define krecord1_hashcode(car,cdr) pair_hashcode1(car,cdr,krecord1_hash_size)

#ifdef OBSOLETE
IMPORT Boolean ExpandKtuple2Table P((IN unsigned long size));
IMPORT Boolean ExpandKonsTable P((IN unsigned long size));
IMPORT Boolean ExpandMapletKonsTable P((IN unsigned long size));
IMPORT Boolean ExpandMapKonsTable P((IN unsigned long size));
IMPORT Boolean ExpandKcomplexTable P((IN unsigned long size));
IMPORT Boolean ExpandKtypeApplTable P((IN unsigned long size));
IMPORT Boolean ExpandKtypeFxTable P((IN unsigned long size));
IMPORT Boolean ExpandKrecord1Table P((IN unsigned long size));
#endif

IMPORT Boolean ResizeKtuple2Table P((IN unsigned long size));
IMPORT Boolean ResizeKonsTable P((IN unsigned long size));
IMPORT Boolean ResizeMapletKonsTable P((IN unsigned long size));
IMPORT Boolean ResizeMapKonsTable P((IN unsigned long size));
IMPORT Boolean ResizeKcomplexTable P((IN unsigned long size));
IMPORT Boolean ResizeKtypeApplTable P((IN unsigned long size));
IMPORT Boolean ResizeKtypeFxTable P((IN unsigned long size));
IMPORT Boolean ResizeKrecord1Table P((IN unsigned long size));

#define data_hashcode1(magic,car,cdr,siz) \
	(((((unsigned long)car)+((unsigned long)cdr) >> NLOWBITS)+((unsigned long)magic))) % (siz)
#define data_hashcode(magic,car,cdr) data_hashcode1(magic,car,cdr,data_hash_size)
IMPORT Boolean ExpandDataTable P((IN unsigned long size));

#define int_hashcode1(i,siz) ((unsigned long)i) % (siz)
#define int_hashcode(i) int_hashcode1(i,int_hash_size)
IMPORT Boolean ExpandIntTable P((IN unsigned long size));

#if REAL_SIZE>=2*LONG_SIZE
#define real_hashcode1(x,siz) (((unsigned long *)x)[0]+((unsigned long *)x)[1]) % (siz)
#else
#define real_hashcode1(x,siz) ((unsigned long *)x)[0] % (siz)
#endif
#define real_hashcode(x) real_hashcode1(x,real_hash_size)
IMPORT Boolean ExpandRealTable P((IN unsigned long size));

IMPORT COUNTER string_hashcode1 P((IN INT len,IN CONST CHAR *name,
				   IN unsigned long size));
#define string_hashcode(len,name) string_hashcode1(len,name,string_hash_size)
IMPORT Boolean ExpandStringTable P((IN unsigned long size));

#define var_hashcode(i,level) (((unsigned long)((i)+(level)))>>4) % VAR_HASH_SIZE

#define ref_hashcode(expr) (((unsigned long)expr)>>NLOWBITS) % REF_HASH_SIZE

IMPORT COUNTER array_hashcode1 P((IN INT n,IN CONST ExprPtr *exprs, IN ExprKind kind, IN CONST ExprPtr shape, IN unsigned long size));
#define array_hashcode(n,exprs,kind,shape) array_hashcode1(n,exprs,kind,shape,array_hash_size)

#ifdef OBSOLETE
IMPORT Boolean ExpandArrayTable P((IN unsigned long size));
#endif

IMPORT Boolean ResizeArrayTable P((IN unsigned long size));
