/* Compiler to C auxiliary functions, headers.
   Copyright (C) 2004,2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef OBSOLETE
typedef struct cxBuffer {
  struct cxBuffer *next;
  CHAR c[1];
} cxBuffer;

typedef struct cxFile {
  INT nargs;
  INT stackDepth, maxStackDepth;
  INT mapStackDepth, maxMapStackDepth;
  INT cStackDepth, maxCStackDepth;
  COUNTER ncvars;
  COUNTER dead; /* true if all code that would be output would be dead */
  cxBuffer *decls;
  cxBuffer **lastdeclp;
  cxBuffer *actions;
  cxBuffer **lastactionp;
  COUNTER cvars[BC_STACK_SIZE];
  /* from 0..stackDepth-1; used to
     give the actual C name of variable
     i, 0<=i<stackDepth.
     If k = cvars[i]>=0, then name is '_x.p[k]'.
     If k = cvars[i]<0, then name is '_x<-k>'.
  */
} cxFile;

IMPORT cxFile *cxOpen P((void));
IMPORT void cxOutDecl P((INOUT cxFile *f, IN CONST CHAR *s));
IMPORT void cxOutAction P((INOUT cxFile *f, IN CONST CHAR *s));
IMPORT void cxPush P((IN COUNTER amount, IN cxFile *f));
IMPORT void cxMapPush P((IN COUNTER amount, IN cxFile *f));
IMPORT void cxLet P((INOUT cxFile *f));
IMPORT void cxLetProtect P((INOUT cxFile *f));

IMPORT CHAR *cxVarName P((IN CONST cxFile *f, IN COUNTER i));
#endif

IMPORT ExprPtr bcXName P((IN CONST struct byteCodeChunk *bc));

IMPORT void bcXlate0 P((IN hFILE *out,
			IN CONST struct byteCodeChunk *bc));

IMPORT void bcXoutProtos P((IN hFILE *out));
IMPORT void bcXout P((IN hFILE *out));
IMPORT ExprPtr bcXdefs P((IN hFILE *out));
IMPORT void bcXoutCode P((IN hFILE *out));
