/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#define NSUBEXP  10
/* initial value was 10 [jg may 18, 1996],
 and cannot be changed, since \1,..., \9 are all we have to
 recall stored substrings. */

typedef struct regexp {
  COUNTER regsize; /* size of the regexp structure [jg] */
  ExprPtr matched; /* string currently being matched [jg] */
  char *mstart; /* STEXT of matched when last used by regexec() */
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;

extern regexp *regcomp P((IN CONST ExprPtr str));
extern CHAR *regexec P((IN CONST regexp *prog,IN CONST ExprPtr string,
			IN INT start,IN INT end));
extern ExprPtr regsub P((IN CONST regexp *prog,IN CONST ExprPtr source));
/*extern void regerror();*/
EXTERN ExprPtr raiseRE P((void));

struct reg1 {
  int paren;
  int flag;
  CHAR *res;
};

struct regmatch1 {
  CHAR *prog;
#if STOP_AND_COPY_VECTORS
  CHAR *stext;
#endif
  int res;
};

/* Failure modes [jg] */
extern int regexperr;
#define RE_NOERR 0
#define RE_TOOBIG 1
#define RE_TOOMANYPARENS 2
#define RE_UNMATCHEDPARENS 3
#define RE_JUNKONEND 4
#define RE_STARPLUSOPEMPTY 5
#define RE_NESTEDSTARQUESPLUS 6
#define RE_INVALBRAC 7
#define RE_UNMATCHEDBRAC 8
#define RE_INTERNALURP 9
#define RE_QUESPLUSSTARAFTERNIL 10
#define RE_TRAILBACK 11
#define N_RE_MSG 12
