/* Static structures for print.c.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct printmapnotype {
  printFunc doprint;
  char *printdata;
  Boolean comma;
};

struct valprtn {
  ExprPtr val;
  printFunc doprint;
  char *printdata;
  COUNTER pri;
};

struct printmap {
  printFunc doprint;
  char *printdata;
  ExprPtr domtype,rngtype;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

#ifdef OLDDATA
struct datacon {
  ExprPtr tag;
  ExprPtr con;
  Boolean possiblemultiple;
  Boolean multiple;
};
#endif

struct printrecord {
  printFunc doprint;
  char *printdata;
  ExprPtr type;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

struct printnum {
  printFunc doprint;
  char *printdata;
  Boolean comma;
};

struct valprt {
  ExprPtr val;
  ExprPtr type;
  printFunc doprint;
  char *printdata;
  COUNTER pri;
};

struct overflow {
  COUNTER lmargin,rmargin;
  ExprPtr exit;
};

struct prtoverflow {
  ExprPtr val;
  ExprPtr type;
  COUNTER lmargin,rmargin;
  COUNTER pri;
};

struct strcut {
  CHAR *text;
  INT len;
  struct overflow data;
};

struct prettymap {
  ExprPtr x,y;
  struct overflow data;
  struct printmap data2;
};

struct valprint {
  printFunc doprint;
  char *printdata;
  MapPtr locs;
};

struct valpretty {
  ExprPtr val;
  ExprPtr type;
  printFunc doprint;
  char *printdata;
  COUNTER pri;
  COUNTER lmargin,rmargin;
  Boolean res;
};

struct typeprintmap {
  printFunc doprint;
  char *printdata;
  ExprPtr state;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

struct typeprint {
  ExprPtr type;
  printFunc doprint;
  char *printdata;
  ExprPtr state;
  COUNTER pri;
};

struct prttypeoverflow {
  ExprPtr type;
  ExprPtr state;
  COUNTER pri;
  struct overflow data;
};

struct prtfxoverflow {
  ExprPtr constr;
  ExprPtr state;
  COUNTER pri;
  struct overflow data;
};

struct typepretty {
  ExprPtr type;
  printFunc doprint;
  char *printdata;
  ExprPtr state;
  COUNTER pri;
  COUNTER lmargin,rmargin;
  Boolean res;
};

struct printstring {
  COUNTER len;
  COUNTER maxlen; /* buf must contain at least maxlen+1 characters */
  CHAR *buf;
};
