/* static declarations for file bc.c */
static void arglistSweep P((char *, doExtDesc *));
static ExprPtr arglistLoad P((extDesc *, Boolean, ExprPtr, loadAction));
static ExprPtr arglistCons P((ExprPtr, compEnv *, ExprPtr));
static ExprPtr arglistNext P((ExprPtr));
static compEnv *arglistEnv P((ExprPtr));
static ExprPtr arglistArg P((ExprPtr));
static void compileCGlobal P((bcFile *, long));
static long findConstant P((bcFile *, ExprPtr));
static void compileConstant P((bcFile *, ExprPtr));
static void compileClosure P((bcFile *, ExprPtr));
static void compileFetch P((bcFile *, long));
static void compileFetchCar P((bcFile *, long));
static void compileFetchCdr P((bcFile *, long));
static void compileFetchRefVal P((bcFile *, long));
static void compileNth P((bcFile *, long));
static void bcdPutInt P((long, bcFile *));
static void compileCodePoint P((bcFile *));
static long getCurIEnv P((compEnv *));
static long getCurEnv P((compEnv *));
static void newCurEnv P((compEnv *, int));
static void compileCurEnv P((bcFile *, compEnv *));
static void compileCurIEnv P((bcFile *, compEnv *));
static void compileClosureEnv P((bcFile *, ExprPtr, compEnv *));
static bcFile *bcOpenD P((compEnv *));
static ExprPtr bcCloseD P((bcFile *));
static void compileDataCon P((bcFile *, compEnv *, long, ExprPtr));
static void compileVarref P((bcFile *, compEnv *, int, int));
static Boolean debugVarref P((bcFile *, compEnv *, int, int));
static void compileSwDrop P((bcFile *, long));
static ExprPtr beginForward P((bcFile *));
static void endForward0 P((bcFile *, ExprPtr));
static void endForward P((bcFile *, ExprPtr));
static ExprPtr beginBackward P((bcFile *));
static long beginDebug P((bcFile *, bcdState *));
static void endDebug P((long, bcFile *, bcdState *));
static void setStackDepth P((bcFile *, int));
static void compileRaise P((bcFile *, compEnv *));
static void compileRaiseImm P((bcFile *, compEnv *, long));
static void compileExprFun P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static ExprPtr do_restricttolevel P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr restrictToLevel P((ExprPtr, ExprPtr, long));
static Boolean do_resetdbgnames P((ExprPtr, ExprPtr, unsigned char *));
static void resetDbgNames P((compEnv *));
static void compileLet1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, Boolean));
static Boolean do_dumpletstores P((ExprPtr, ExprPtr, unsigned char *));
static void dumpLetStores P((bcFile *, long, ExprPtr));
static Boolean do_flushdbgnames P((ExprPtr, ExprPtr, unsigned char *));
static void flushDbgNames P((bcFile *, compEnv *));
static void addLetDelay P((compEnv *, long, long));
static void addDbgName P((compEnv *, long, ExprPtr));
static ExprPtr compilePatternAt P((bcFile *, compEnv *, ExprPtr, int, ExprPtr, ExprPtr, Boolean));
static ExprPtr compileVectorMatch1 P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr, ExprPtr));
static ExprPtr newChoice P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, int, int, int));
static Boolean isTruePat P((ExprPtr));
static Boolean isFalsePat P((ExprPtr));
static Boolean nontrivMatch P((ExprPtr));
static ExprPtr compileVectorMatch P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr, ExprPtr));
static ExprPtr compileNfoldMatch P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr, ExprPtr));
static ExprPtr compileTupleMatch P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compileRecordMatch P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static void compileCheckTag P((bcFile *, ExprPtr, ExprPtr));
static void compileCheckCardEq P((bcFile *, int, ExprPtr));
static void compileCheckCardGeq P((bcFile *, int, ExprPtr));
static void compileSelectGnrl P((bcFile *, compEnv *, ExprPtr));
static ExprPtr compileRecordGnrlMapAddMatch1 P((bcFile *, compEnv *, ExprPtr, int, ExprPtr, ExprPtr));
static ExprPtr compileRecordGnrlMapAddMatch P((bcFile *, compEnv *, ExprPtr, int, ExprPtr, ExprPtr));
static ExprPtr compileRecordMapAddMatch P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static Boolean cstPattern P((ExprPtr, ExprPtr *));
static void compileDrop P((bcFile *, int));
static void compilePushDrop P((bcFile *, int, Boolean));
static void compileMapDrop P((bcFile *, int));
static long getDataTag P((ExprPtr, ExprPtr *));
static ExprPtr addDataTag P((ExprPtr, ExprPtr, ExprPtr, ExprPtr *));
static ExprPtr collectDataTags P((ExprPtr, ExprPtr, ExprPtr *, ExprPtr *));
static ExprPtr compileMapletPattern P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compileMapAddPatternGnrl P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compilePatSwitch P((bcFile *, compEnv *, ExprPtr, ExprPtr *, ExprPtr, ExprPtr *));
static ExprPtr compilePattern1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, Boolean));
static ExprPtr compilePattern P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, Boolean));
static void defineMe P((compEnv *, ExprPtr));
static void compileBinding1 P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileBinding P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileBindings P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileLet P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileExprOrAppl P((bcFile *, compEnv *, ExprPtr));
static void compileStmtFun P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileStmtOrAppl P((bcFile *, compEnv *, ExprPtr));
static void compileExprOrApplNargs P((bcFile *, compEnv *, ExprPtr, int));
static int tryNargs P((ExprPtr));
static int tryNformals1 P((ExprPtr));
static int tryNformals P((ExprPtr));
static ExprPtr compilePolyFun0 P((bcFile *, compEnv *, ExprPtr, int, compileFunc, int, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compilePolyFun1k P((bcFile *, compEnv *, ExprPtr, int, compileFunc, int, ExprPtr, ExprPtr));
static ExprPtr compilePolyFun1 P((bcFile *, compEnv *, ExprPtr, int, compileFunc, int, ExprPtr, ExprPtr));
static void compilePolyFun P((bcFile *, compEnv *, ExprPtr, Boolean));
static void compileMemoFn P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static ExprPtr forgetExtra P((ExprPtr));
static Boolean isMe P((compEnv *, ExprPtr));
static void compileTwoArgs P((bcFile *, compEnv *, ExprPtr, Boolean));
static void compileThreeArgs P((bcFile *, compEnv *, ExprPtr));
static Boolean compileOneArgAndMaplet P((bcFile *, compEnv *, ExprPtr));
static void testToBool P((bcFile *, ExprPtr));
static ExprPtr compilePrimitive P((bcFile *, compEnv *, ExprPtr, compEnv *, ExprPtr, ExprPtr, Boolean, compileFunc, Boolean, ExprPtr));
static void compileApply1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, Boolean, compileFunc, Boolean, ExprPtr));
static void compileApply P((bcFile *, compEnv *, ExprPtr, ExprPtr, Boolean, compileFunc, Boolean, ExprPtr));
static void compileMapGet P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileTupleSelect P((bcFile *, ExprPtr));
static void compileRecordSelect P((bcFile *, compEnv *, ExprPtr));
static void compileMu1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, Boolean));
static void compileMuGnrl P((bcFile *, compEnv *, ExprPtr, ExprPtr, Boolean));
static void compileCombine1None P((bcFile *, compEnv *));
static void compileCombineNone P((bcFile *, compEnv *, int));
static void compileFinalizeNone P((bcFile *, compEnv *));
static void compileEvalPromoteExists P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileEvalPromoteAll P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileNeutralSome P((bcFile *, compEnv *));
static void compileEvalPromoteSome P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileEvalPromoteUnsharedSome P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileExprErr P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileEvalPromoteProg P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileNeutralList P((bcFile *, compEnv *));
static void compileCombineList P((bcFile *, compEnv *, int));
static void compileEvalPromoteList P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileFinalizeList P((bcFile *, compEnv *));
static void compileFinalizeUnsharedList P((bcFile *, compEnv *));
static void compileNeutralSet P((bcFile *, compEnv *));
static void compileCombineSet P((bcFile *, compEnv *, int));
static void compileEvalPromoteSet P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileEvalPromoteAppend P((bcFile *, compEnv *, ExprPtr, int, int, ExprPtr));
static void compileCombineUnionUnder P((bcFile *, compEnv *, int));
static void compileNeutralInter P((bcFile *, compEnv *));
static void compileCombineInter P((bcFile *, compEnv *, int));
static void compileOneOf P((bcFile *, compEnv *, unsigned char *, ExprPtr, int, int, ExprPtr));
static void startSweep P((bcFile *, long, long, struct sweepinfo *));
static void getSweep P((bcFile *, long, struct sweepinfo *));
static void incSweep P((bcFile *, long, struct sweepinfo *, ExprPtr));
static void compileSweep P((bcFile *, compEnv *, long, long, compileCombineFunc, compileCombine1Func, compileNeutralFunc, compileBodyFunc, unsigned char *, ExprPtr, int, int, ExprPtr, int, int, Boolean));
static ExprPtr compileMapAddPatternGnrlk P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compileMapAddPatternGnrl1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr compileSimpleOf1 P((bcFile *, compEnv *, struct compilesimpleof *, ExprPtr, int, int, ExprPtr, int));
static void compileSimpleOf P((bcFile *, compEnv *, struct compilesimpleof *, ExprPtr, int, int, ExprPtr, int));
static void compileMapBodyPred P((bcFile *, compEnv *, struct compilesimpleof *, struct sweepinfo *, ExprPtr, int, int, ExprPtr));
static void compileMapInc P((bcFile *, compEnv *, struct compilesimpleof *, struct sweepinfo *, ExprPtr, ExprPtr));
static void compileSimpleMap P((bcFile *, compEnv *, struct compilesimpleof *, ExprPtr, int, int, ExprPtr, ExprPtr));
static ExprPtr compileDomainsSimple1k P((bcFile *, compEnv *, ExprPtr, ExprPtr *));
static long getExprIndex P((bcFile *, compEnv *, ExprPtr));
static ExprPtr compileDomainsSimple1 P((bcFile *, compEnv *, ExprPtr, ExprPtr *));
static ExprPtr compileDomainsSimple P((bcFile *, compEnv *, ExprPtr, ExprPtr *));
static void fillData P((struct compilesimpleof *, IterKind));
static void compileFinalOf P((bcFile *, compEnv *, struct compilesimpleof *, int, int, ExprPtr, ExprPtr));
static void compileOf1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, IterKind, int, int, ExprPtr, long));
static void compileMap1 P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, IterKind, int, int, ExprPtr, long));
static void compileOf P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, IterKind, int, int, ExprPtr));
static void compileMap P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, IterKind, int, int, ExprPtr));
static void compileOfNoFuss P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileMapNoFuss P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileSomeOf P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileSomeMap P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileWhile P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr, IterKind, int, int, ExprPtr));
static void compileWhileNoFuss P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileSomeWhile P((bcFile *, compEnv *, ExprPtr, IterKind));
static void compileHandle P((bcFile *, compEnv *, ExprPtr, ExprPtr, compileFunc, Boolean, ExprPtr));
static ExprPtr compileTest1 P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileTest P((bcFile *, compEnv *, ExprPtr, ExprPtr));
static void compileTestExpr P((bcFile *, compEnv *, ExprPtr));
static void compileIf P((bcFile *, compEnv *, ExprPtr, ExprPtr, ExprPtr));
static void compileStmt1 P((bcFile *, compEnv *, ExprPtr));
static void compileStmt P((bcFile *, compEnv *, ExprPtr));
static void compileStmtExpr P((bcFile *, compEnv *, ExprPtr));
static ExprPtr compileExpr1 P((bcFile *, compEnv *, ExprPtr));
static void compileExpr P((bcFile *, compEnv *, ExprPtr));
