/* Useful global string constants.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "eval.h"
#include "expr.h"
#include "symproto.h"
#ifdef HAS_PROTOTYPES
#include "ssymbols.h"
#endif

PUBLIC SymPtr stringsym,stringSym,intsym,intSym,listsym,listSym,
  refsym,refSym,funSym,mapSym,optsym,optSym,
  boolsym,boolSym,exnsym,exnSym,
  dynsym,dynSym,arraysym,arraySym,catchSym,
  iarraysym, iarraySym, tablesym, tableSym,
  promisesym,promiseSym,contsym,contSym,
  unitsym,outstreamsym,instreamsym,
  writesym,readsym,readlinesym,flushsym,
  tellsym,seeksym,advancesym,seekendsym,suspendsym,
  truncatesym,convertsym,killsym,rematchsym,resubstsym,
  rematchfullsym,rematchpsym,noneSym,someSym;
PUBLIC SymPtr alpha,alphaeq,_alpha,_alphaeq,beta,_beta,
	betaeq,gama,gamaeq,numalpha,numbeta;
/* the name gamma may have been taken by the system to denote
the gamma function, so we use gama instead */
PUBLIC ExprPtr num_alpha,num_beta;
PUBLIC SymPtr nilSym,consSym,trueSym,derefSym,assignSym,forceSym,
	bindSym,matchSym,emptySym,mapgetSym,
	parsweepSym,nomemSym,nonsenseSym,
	stackSym,incompSym,noninvSym,nthSym,
	rangeSym,asciiSym,stringnthSym,
	subscriptSym,arithSym,ioSym,reSym,
	ufindSym,futureSym,
	appendSym,dunionSym,overwriteSym,
	underwriteSym,interSym,identitySym,
	mergeSym,equalSym,mapappSym,
	equalitySym,discrSym;
PUBLIC SymPtr itSym,it2Sym;
PUBLIC SymPtr falseSym,trueSym;
PUBLIC SymPtr starSym,unionSym,concSym;
PUBLIC SymPtr powerSym;
PUBLIC SymPtr ellSym,elleqSym,ellimpSym,elleqimpSym;
PUBLIC SymPtr trueValue,falseValue;
#if IMPERATIVE_TYPES==EFFECT_TYVAR
PUBLIC ExprPtr fxInitSym,fxReadSym,fxWriteSym,fxExnSym,fxFromSym,fxGotoSym,fxTopSym;
PUBLIC ExprPtr rgnSym,effectSym;
PUBLIC ExprPtr pureGenFx,genRgn;
#endif

#define __SEG__ INIT

PRIVATE ExprPtr KSYMBOL(n)
IN COUNTER n;
{
  ExprPtr sym;

  sym = Ksymbol(message(n));
  return sym;
}

PUBLIC void InitSymbols()
{
  ENTER;
  itSym = KSYMBOL(159);
  it2Sym = KSYMBOL(388);
  stringsym = KSYMBOL(160);
  stringSym = KSYMBOL(161);
  intsym = KSYMBOL(487);
  intSym = KSYMBOL(488);
  listsym = KSYMBOL(162);
  listSym = KSYMBOL(163);
  refsym = KSYMBOL(164);
  refSym = KSYMBOL(165);
  arraysym = KSYMBOL(166);
  arraySym = KSYMBOL(167);
  iarraysym = KSYMBOL(247);
  iarraySym = KSYMBOL(248);
  tableSym = KSYMBOL(937);
  tablesym = KSYMBOL(938);
  funSym = KSYMBOL(168);
  mapSym = KSYMBOL(169);
  optsym = KSYMBOL(595);
  optSym = KSYMBOL(652);
  boolsym = KSYMBOL(170);
  boolSym = KSYMBOL(171);
  exnsym = KSYMBOL(172);
  exnSym = KSYMBOL(173);
  dynsym = KSYMBOL(174);
  dynSym = KSYMBOL(175);
  promisesym = KSYMBOL(176);
  promiseSym = KSYMBOL(177);
  unitsym = KSYMBOL(178);
  contsym = KSYMBOL(179);
  contSym = KSYMBOL(180);
  alpha = KSYMBOL(181);
  alphaeq = KSYMBOL(182);
  _alpha = KSYMBOL(183);
  _alphaeq = KSYMBOL(932);
  beta = KSYMBOL(184);
  _beta = KSYMBOL(185);
  betaeq = KSYMBOL(186);
  gama = KSYMBOL(187);
  gamaeq = KSYMBOL(188);
  numalpha = KSYMBOL(189); (void) KEEP(numalpha);
  num_alpha = KnumType(MapSingleton(numalpha,one));
  numbeta = KSYMBOL(190); (void) KEEP(numbeta);
  num_beta = KnumType(MapSingleton(numbeta,one));
  nilSym = KSYMBOL(192);
  consSym = KSYMBOL(193);
  derefSym = KSYMBOL(344);
  assignSym = KSYMBOL(343);
  forceSym = KSYMBOL(194);
  bindSym = KSYMBOL(195);
  matchSym = KSYMBOL(196);
  emptySym = KSYMBOL(197);
  mapgetSym = KSYMBOL(198);
  parsweepSym = KSYMBOL(199);
  nomemSym = KSYMBOL(200);
  stackSym = KSYMBOL(201);
  incompSym = KSYMBOL(202);
  noninvSym = KSYMBOL(203);
  nthSym = KSYMBOL(204);
  rangeSym = KSYMBOL(205);
  asciiSym = KSYMBOL(206);
  stringnthSym = KSYMBOL(207);
  nonsenseSym = KSYMBOL(208);
  futureSym = KSYMBOL(804);
  catchSym = KSYMBOL(482);
  subscriptSym = KSYMBOL(209);
  arithSym = KSYMBOL(210);
  ioSym = KSYMBOL(433);
  reSym = KSYMBOL(545);
  appendSym = KSYMBOL(211);
  dunionSym = KSYMBOL(212);
  overwriteSym = KSYMBOL(213);
  underwriteSym = KSYMBOL(214);
  interSym = KSYMBOL(215);
  identitySym = KSYMBOL(216);
  mergeSym = KSYMBOL(217);
  mapappSym = KSYMBOL(219);
  falseSym = KSYMBOL(220);
  trueSym = KSYMBOL(221);
  starSym = KSYMBOL(222);
  unionSym = KSYMBOL(223);
  concSym = KSYMBOL(224);
  powerSym = KSYMBOL(225);
  ellSym = KSYMBOL(226);
  elleqSym = KSYMBOL(227);
  ellimpSym = KSYMBOL(228);
  elleqimpSym = KSYMBOL(229);
  equalSym = KSYMBOL(230);
  equalitySym = KSYMBOL(231);
  discrSym = KSYMBOL(232);
  {
    ExprPtr ttm,f;
    ExprPtr shape[2];

    trueSym = KSYMBOL(233);
    f = KSYMBOL(234);
    shape[0] = trueSym;
    shape[1] = f;
    ttm = Karray(E_ARRAY_GNRL,NIL,2,shape);
    ttm = Kdata((SHORT)-2,ttm,NIL);
    CGlobals[I_TRUEVALUE] = trueValue = Kdata((SHORT)-2,ttm,NIL);
    CGlobals[I_FALSEVALUE] = falseValue = Kdata((SHORT)-1,ttm,NIL);
  }
  outstreamsym = KSYMBOL(434);
  instreamsym = KSYMBOL(446);
  writesym = KSYMBOL(447);
  readsym = KSYMBOL(448);
  readlinesym = KSYMBOL(450);
  flushsym = KSYMBOL(449);
  tellsym = KSYMBOL(451);
  seeksym = KSYMBOL(452);
  advancesym = KSYMBOL(460);
  seekendsym = KSYMBOL(461);
  suspendsym = KSYMBOL(802);
  killsym = KSYMBOL(493);
  truncatesym = KSYMBOL(814);
  convertsym = KSYMBOL(815);
  rematchsym = KSYMBOL(546);
  resubstsym = KSYMBOL(547);
  rematchfullsym = KSYMBOL(562);
  rematchpsym = KSYMBOL(563);
  noneSym = KSYMBOL(653);
  someSym = KSYMBOL(825);
#if IMPERATIVE_TYPES==EFFECT_TYVAR
  fxInitSym = KSYMBOL(393);
  fxReadSym = KSYMBOL(394);
  fxWriteSym = KSYMBOL(403);
  fxExnSym = KSYMBOL(619);
  fxFromSym = KSYMBOL(408);
  fxGotoSym = KSYMBOL(467);
  fxTopSym = KSYMBOL(468);
  rgnSym = KSYMBOL(469);
  effectSym = KSYMBOL(470);
  pureGenFx = MakePair(E_ARRAY_2,effectSym,NewMap());
  genRgn = MakePair(E_ARRAY_2,rgnSym,NewMap());
#endif
  ufindSym = KSYMBOL(626);
  QUIT;
}
